diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 1243dfa7a..49223206e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -2,6 +2,8 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
@@ -10,15 +12,13 @@ import net.minecraft.core.world.noise.PerlinNoise;
 import java.util.Random;
 
 public class SurfaceGeneratorNether
-    implements SurfaceGenerator
-{
+    implements SurfaceGenerator {
     private final World world;
 
     private final PerlinNoise beachNoise;
     private final PerlinNoise soilNoise;
 
-    public SurfaceGeneratorNether(World world)
-    {
+    public SurfaceGeneratorNether(World world) {
         this.world = world;
 
         beachNoise = new PerlinNoise(world.getRandomSeed(), 4, 40);
@@ -26,8 +26,7 @@ public class SurfaceGeneratorNether
     }
 
     @Override
-    public void generateSurface(Chunk chunk, ChunkGeneratorResult result)
-    {
+    public void generateSurface(Chunk chunk, ChunkGeneratorResult result) {
         int oceanY = world.getWorldType().getOceanY();
         int minY = world.getWorldType().getMinY();
         int maxY = world.getWorldType().getMaxY();
@@ -43,82 +42,84 @@ public class SurfaceGeneratorNether
         double[] sandBeachNoise = beachNoise.get(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
         double[] gravelBeachNoise = beachNoise.get(null, chunkX * 16, 109.0134D, chunkZ * 16, 16, 1, 16, beachScale, 1.0D, beachScale);
         double[] soilThicknessNoise = soilNoise.get(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
-        for(int z = 0; z < 16; z++)
-        {
-            for(int x = 0; x < 16; x++)
-            {
+        for (int z = 0; z < 16; z++) {
+            for (int x = 0; x < 16; x++) {
                 boolean generateSandBeach = sandBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
                 boolean generateGravelBeach = gravelBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
-                int soilThickness = (int)(soilThicknessNoise[z + x * 16] / 3D + 3D + rand.nextDouble() * 0.25D);
+                int soilThickness = (int) (soilThicknessNoise[z + x * 16] / 3D + 3D + rand.nextDouble() * 0.25D);
 
                 int currentLayerDepth = -1;
-                short topBlock = (short) worldFillBlock;
-                short fillerBlock = (short) worldFillBlock;
+                short topBlock = -1;
+                short fillerBlock = -1;
+
+                Biome lastBiome = null;
+
+                for (int y = maxY; y >= minY; y--) {
+                    Biome biome = chunk.getBlockBiome(x, y, z);
+                    if (biome == null)
+                        biome = world.getBiomeProvider().getBiome(chunkX * Chunk.CHUNK_SIZE_X + x, y >> 3, chunkZ * Chunk.CHUNK_SIZE_Z + z);
 
-                for(int y = maxY; y >= minY; y--)
-                {
                     int block = result.getBlock(x, y, z);
 
-                    // reset the currently generating surface thickness to 0 if encountered air
-                    if(block == 0)
-                    {
+                    if ((biome != lastBiome || topBlock == -1 || fillerBlock == -1) && block == 0) {
+                        topBlock = biome.topBlock;
+                        fillerBlock = biome.fillerBlock;
+                    }
+                    lastBiome = biome;
+
+                    // reset the currently generating surface thickness to -1 if encountered air
+                    if (block == 0) {
                         currentLayerDepth = -1;
                         continue;
                     }
 
                     // will skip a generation loop if it encounters something other than netherrack
-                    if(block != worldFillBlock)
-                    {
+                    if (block != worldFillBlock) {
                         continue;
                     }
 
                     // if thickness == -1, find what block to place on layer level
-                    if(currentLayerDepth == -1)
-                    {
+                    if (currentLayerDepth == -1) {
                         // if soil thickness is below 0, generate a stone basin where there is no top block layer
-                        if(soilThickness <= 0)
-                        {
+                        if (soilThickness <= 0) {
                             topBlock = 0;
                             fillerBlock = (short) worldFillBlock;
-                        }
-                        else if(y >= minY + oceanY - 4 && y <= minY + oceanY + 1)
-                        {
-                            // Generate coastlines
-                            topBlock = (short) worldFillBlock;
-                            fillerBlock = (short) worldFillBlock;
-                            if(generateGravelBeach)
-                            {
-                                topBlock = (short) Blocks.GRAVEL.id();
-                            }
-                            if(generateGravelBeach)
-                            {
-                                fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id();
-                            }
-                            if(generateSandBeach)
-                            {
-                                topBlock = (short) Blocks.SOULSAND.id();
-                            }
-                            if(generateSandBeach)
-                            {
-                                fillerBlock = (short) Blocks.SOULSAND.id();
+                        } else {
+                            boolean biomeGeneratesSulfur = biome == Biomes.NETHER_SULFUR_POOLS;
+
+                            if (y >= minY + oceanY - 4 && y <= minY + oceanY + 1) {
+                                // Generate coastlines
+                                topBlock = biome.topBlock;
+                                fillerBlock = biome.fillerBlock;
+                                if (biomeGeneratesSulfur) {
+                                    topBlock = (short) Blocks.SULFUR.id();
+                                    fillerBlock = (short) Blocks.SULFUR.id();
+                                } else if (generateGravelBeach) {
+                                    topBlock = (short) Blocks.GRAVEL.id();
+                                    fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id();
+                                } else if (generateSandBeach) {
+                                    topBlock = (short) Blocks.SOULSAND.id();
+                                    fillerBlock = (short) Blocks.SOULSAND.id();
+                                }
+                            } else if (y <= oceanY) {
+                                if (biomeGeneratesSulfur) {
+                                    topBlock = (short) Blocks.SULFUR.id();
+                                    fillerBlock = (short) Blocks.SULFUR.id();
+                                }
                             }
                         }
 
                         // failsafe so that if a basin is generated under the ocean, the ocean is not replaced with air
-                        if(y < minY + oceanY && topBlock == 0)
-                        {
+                        if (y < minY + oceanY && topBlock == 0) {
                             topBlock = (short) oceanBlock;
                         }
                         // if a new surface layer has been chosen to be generated, set the current layer depth to the generated soil thickness level and begin generating downwards
                         currentLayerDepth = soilThickness;
 
                         // set block at index to designated surface block above ocean level
-                        if(y >= minY + oceanY - 1)
-                        {
+                        if (y >= minY + oceanY - 1) {
                             result.setBlock(x, y, z, topBlock);
-                        }
-                        else
-                        {
+                        } else {
                             // if the block is below ocean level, set it to the chosen filler block
                             result.setBlock(x, y, z, fillerBlock);
                         }
@@ -126,8 +127,7 @@ public class SurfaceGeneratorNether
                     }
 
                     // fill blocks with filler block until current layer level = -1 or air is encountered
-                    if(currentLayerDepth > 0)
-                    {
+                    if (currentLayerDepth > 0) {
                         currentLayerDepth--;
                         result.setBlock(x, y, z, fillerBlock);
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 6534b0bb8..03772c650 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -2,25 +2,71 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
 import net.minecraft.core.world.type.WorldType;
 
+import java.util.HashMap;
+import java.util.Map;
+
 public class TerrainGeneratorNether
     extends TerrainGeneratorLerp
 {
     private final DensityGenerator densityGenerator;
 
+    private int lastX = -1;
+    private int lastZ = -1;
+    private Biome lastBiome = null;
+    private Biome lastBiomeNegX = null;
+    private Biome lastBiomePosX = null;
+    private Biome lastBiomeNegZ = null;
+    private Biome lastBiomePosZ = null;
+    private Map<Biome, Integer> fluidLookup = new HashMap<>();
+
     public TerrainGeneratorNether(World world)
     {
         super(world);
 
         this.densityGenerator = new DensityGeneratorNether(world);
+
+        this.fluidLookup.put(Biomes.NETHER_NETHER, Blocks.FLUID_LAVA_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_VOLCANIC_ISLANDS, Blocks.FLUID_LAVA_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_SULFUR_POOLS, Blocks.FLUID_WATER_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FOREST, Blocks.FLUID_WATER_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_ASH_PLAINS, Blocks.OBSIDIAN.id());
+        this.fluidLookup.put(Biomes.NETHER_BONEYARD, Blocks.COBBLE_NETHERRACK.id());
     }
 
     @Override
-    protected int getBlockAt(int x, int y, int z, double density)
+    protected int getBlockAt(Chunk chunk, int x, int y, int z, double density)
     {
+        if (lastX != x || lastZ != z) {
+            lastBiome = chunk.getBlockBiome(x, 0, z);
+            if (x - 1 < 0) {
+                lastBiomeNegX = lastBiome;
+            } else {
+                lastBiomeNegX = chunk.getBlockBiome(x - 1, 0, z);
+            }
+            if (x + 1 >= Chunk.CHUNK_SIZE_X) {
+                lastBiomePosX = lastBiome;
+            } else {
+                lastBiomePosX = chunk.getBlockBiome(x + 1, 0, z);
+            }
+            if (z - 1 < 0) {
+                lastBiomeNegZ = lastBiome;
+            } else {
+                lastBiomeNegZ = chunk.getBlockBiome(x, 0, z - 1);
+            }
+            if (z + 1 >= Chunk.CHUNK_SIZE_Z) {
+                lastBiomePosZ = lastBiome;
+            } else {
+                lastBiomePosZ = chunk.getBlockBiome(x, 0, z + 1);
+            }
+        }
+
         WorldType type = world.getWorldType();
         int halfHeight = type.getMaxY() / 2;
 
@@ -54,7 +100,17 @@ public class TerrainGeneratorNether
         }
         else if (y >= halfHeight && y < type.getOceanY())
         {
-            return type.getOceanBlockId();
+            int biomeFluid = fluidLookup.getOrDefault(lastBiome, 0);
+            int biomeFluidNegX = fluidLookup.getOrDefault(lastBiomeNegX, 0);
+            int biomeFluidPosX = fluidLookup.getOrDefault(lastBiomePosX, 0);
+            int biomeFluidNegZ = fluidLookup.getOrDefault(lastBiomeNegZ, 0);
+            int biomeFluidPosZ = fluidLookup.getOrDefault(lastBiomePosZ, 0);
+
+            if (biomeFluid == biomeFluidNegX && biomeFluid == biomeFluidPosX && biomeFluid == biomeFluidNegZ && biomeFluid == biomeFluidPosZ) {
+                return biomeFluid;
+            }
+
+            return Blocks.OBSIDIAN.id();
         }
 
         return 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index b8e5eeb6d..f0228bf0d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -15,7 +15,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.BiomeOutback;
+import net.minecraft.core.world.biome.overworld.BiomeOutback;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 2f3f21a09..7ad3054d4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
 import net.minecraft.core.world.type.WorldType;
@@ -24,7 +25,7 @@ public class TerrainGeneratorOverworld
     }
 
     @Override
-    protected int getBlockAt(int x, int y, int z, double density)
+    protected int getBlockAt(Chunk chunk, int x, int y, int z, double density)
     {
         WorldType type = world.getWorldType();
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
index f2b0a228a..79f38ccdd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.paradise;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
 import net.minecraft.core.world.type.WorldType;
@@ -24,7 +25,7 @@ public class TerrainGeneratorParadise
     }
 
     @Override
-    protected int getBlockAt(int x, int y, int z, double density)
+    protected int getBlockAt(Chunk chunk, int x, int y, int z, double density)
     {
         WorldType type = world.getWorldType();
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureColdFire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureColdFire.java
new file mode 100644
index 000000000..48f6ffdd6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureColdFire.java
@@ -0,0 +1,31 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeatureColdFire extends WorldFeature
+{
+
+    public WorldFeatureColdFire()
+    {
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        for(int l = 0; l < 64; l++)
+        {
+            int i1 = (x + random.nextInt(8)) - random.nextInt(8);
+            int j1 = (y + random.nextInt(4)) - random.nextInt(4);
+            int k1 = (z + random.nextInt(8)) - random.nextInt(8);
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.SOULSAND.id())
+            {
+                world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE_COLD.id());
+            }
+        }
+
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystal.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystal.java
new file mode 100644
index 000000000..7fab98906
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystal.java
@@ -0,0 +1,105 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeatureCrystal extends WorldFeature
+{
+
+    final double[] RADIUS_MAP_1 = {1.5D, 1D, 0D};
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+
+        int yf = y;
+            int checksForGround = 0;
+
+
+
+            boolean canGenerate = false;
+            while (true) {
+                int blockBelow = world.getBlockId(x, yf - 1, x);
+
+                if (checksForGround > 64 || yf <= 0) {
+                    break;
+                }
+
+                if (Blocks.solid[blockBelow] && blockBelow == Blocks.COBBLE_NETHERRACK.id()) {
+                    canGenerate = true;
+                    break;
+                }
+
+                yf--;
+                checksForGround++;
+            }
+
+            if (canGenerate && world.isAirBlock(x, yf, z)) {
+//                for (int xi = x1 - 1; xi <= x1 + 1; xi++) {
+//                    for (int zi = z1 - 1; zi <= z1 + 1; zi++) {
+//                        for (int yi = yf; yi <= yf + height; yi++) {
+//                            world.setBlock(xi, yi, zi, Blocks.CRYSTAL.id);
+//                        }
+//                    }
+//                }
+//                //cap crystal
+//
+//                for (int i = 0; i < radiusMap.length; i++) {
+//                    generateRadius(world, x1, z1, radiusMap[i], yf + 1 + height + i);
+//                }
+
+                for (int xi = x - 5; xi < x + 5; xi++) {
+                    for (int zi = x - 5; zi < x + 5; zi++) {
+                        for (int yi = yf - 3; yi < yf + 3; yi++) {
+                            if (world.getBlockId(xi, yi, zi) == Blocks.COBBLE_NETHERRACK.id() && world.getBlockId(xi, yi + 1, zi) == 0 && random.nextInt(5) != 0)
+                                world.setBlock(xi, yi, zi, Blocks.NETHERRACK_CRYSTALLINE.id());
+                        }
+                    }
+                }
+            }
+
+
+        return true;
+    }
+
+    private void plotBlocks(World world, int id, int xc, int zc, int x, int y, int z){
+        for(int xx = xc - x; xx <= xc + x; xx++) {
+            world.setBlock(xx, y, zc + z ,id);
+            world.setBlock(xx, y, zc - z, id);
+        }
+
+        for(int xx = xc - z; xx <= xc + z; xx++) {
+            world.setBlock(xx, y, zc + x, id);
+            world.setBlock(xx, y, zc - x, id);
+        }
+    }
+
+    private void generateRadius(World world, int xc, int zc, double r, int y){
+        int x = 0;
+        int z = (int) r;
+        double d = 3 - 2 * r;
+        plotBlocks(world, Blocks.CRYSTAL.id(), xc, zc, x, y, z);
+        while (z > x){
+            x++;
+            if (d > 0) {
+                z--;
+                d = d + 4 * (x - z) + 10;
+            }  else
+                d = d + 4 * x + 6;
+
+            plotBlocks(world, Blocks.CRYSTAL.id(), xc, zc, x, y, z);
+        }
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc){
+        for (int xi = xc - 1; xi < xc + 1; xi++) {
+            for (int zi = zc - 1; zi < zc + 1; zi++) {
+                if (world.getBlockId(xi, y-1, zi) != Blocks.COBBLE_NETHERRACK.id())
+                    return false;
+            }
+        }
+        return true;
+    }
+
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCeiling.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCeiling.java
new file mode 100644
index 000000000..a8876e06d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCeiling.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeatureCrystalCeiling extends WorldFeature
+{
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z)
+    {
+        int x1 = (x + random.nextInt(2)) - random.nextInt(2);
+        int z1 = (z + random.nextInt(2)) - random.nextInt(2);
+        int yF = y;
+
+        double heightMod = 5D;
+
+        int checksForGround = 0;
+        boolean canGenerate = false;
+        while(true){
+            int blockBelow = world.getBlockId(x1, yF+1, z1);
+
+            if(checksForGround > 64 || yF >= world.getHeightBlocks()) {
+                break;
+            }
+
+            if(Blocks.solid[blockBelow]){
+                canGenerate = true;
+                break;
+            }
+
+            yF ++;
+            checksForGround++;
+        }
+
+        double currentHeight = heightMod + random.nextInt(10);
+
+        if(canGenerate && world.isAirBlock(x1, yF, z1))
+        {
+            for(int xi = x - 1; xi < x + 1; xi++){
+                for(int zi = z - 1; zi < z + 1; zi++){
+                    for(int yi = yF; yi > yF - currentHeight; yi--){
+                        world.setBlock(xi, yi, zi, Blocks.CRYSTAL.id());
+                    }
+                    currentHeight = (currentHeight * 0.25D) + random.nextInt(2);
+                }
+            }
+        }
+
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalChunk.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalChunk.java
new file mode 100644
index 000000000..7b7847676
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalChunk.java
@@ -0,0 +1,209 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+import static net.minecraft.core.util.helper.MathHelper.cos;
+import static net.minecraft.core.util.helper.MathHelper.sin;
+
+public class WorldFeatureCrystalChunk extends WorldFeature {
+    private final boolean isCeiling;
+    private final int minHeight;
+    private final int heightMod;
+    private final boolean decorateFloor;
+
+    public WorldFeatureCrystalChunk(boolean isCeiling) {
+        this.isCeiling = isCeiling;
+        this.minHeight = 30;
+        this.heightMod = 50;
+        this.decorateFloor = false;
+    }
+
+    public WorldFeatureCrystalChunk(boolean isCeiling, int minHeight, int heightMod, boolean decorateFloor) {
+        this.isCeiling = isCeiling;
+        this.minHeight = minHeight;
+        this.heightMod = heightMod;
+        this.decorateFloor = decorateFloor;
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+        int x1 = (x + random.nextInt(2)) - random.nextInt(2);
+        int z1 = (z + random.nextInt(2)) - random.nextInt(2);
+        int yF = y;
+
+        int checksForGround = 0;
+        boolean canGenerate = false;
+        while(true){
+            if(isCeiling)
+                yF ++;
+            else
+                yF --;
+
+            if(checksForGround > 64 || yF < 0 || yF >= world.getHeightBlocks()) {
+                break;
+            }
+
+            int blockId = world.getBlockId(x1, yF, z1);
+
+            if(Blocks.solid[blockId]){
+                canGenerate = true;
+                break;
+            }
+
+            checksForGround++;
+        }
+
+        int blockId = world.getBlockId(x1, yF, z1);
+        if(canGenerate && (blockId == Blocks.COBBLE_NETHERRACK.id() || blockId == Blocks.SOULSAND.id())) {
+            if (isCeiling) {
+                yF += 5;
+            } else {
+                yF -= 5;
+            }
+
+            placeCrystal(world, random, x1, yF, z1);
+
+            return true;
+        }
+
+        return false;
+    }
+
+    private void placeCrystal(World world, Random random, final int x, int y, final int z) {
+        float r = random.nextFloat();
+        int length = minHeight + MathHelper.floor(Math.pow(r, 4) * heightMod);
+        int base = length / 4;
+        float rx = 0;
+        float ry = 0;
+        float rz = 0;
+
+        y = isCeiling ? y + (base/2) : y - (base/2);
+
+        if(!hasSpace(world, x, y, z, base)){
+            return;
+        }
+
+        if (isCeiling) {
+            rx = MathHelper.PI;
+        }
+        rx += (float) ((random.nextDouble() - 0.5) * (Math.PI / 2)) * 0.8f;
+        ry += (float) (random.nextDouble() * 2.0 * Math.PI);
+
+        float rxSin = sin(rx), rxCos = cos(rx);
+        float rySin = sin(ry), ryCos = cos(ry);
+        float rzSin = sin(rz), rzCos = cos(rz);
+
+        float[][] rxMatrix = {
+            {1, 0, 0},
+            {0, rxCos, -rxSin},
+            {0, rxSin, rxCos}
+        };
+        float[][] ryMatrix = {
+            {ryCos, 0, rySin},
+            {0, 1, 0},
+            {-rySin, 0, ryCos}
+        };
+        float[][] rzMatrix = {
+            {rzCos, -rzSin, 0},
+            {rzSin, rzCos, 0},
+            {0, 0, 1}
+        };
+
+        float[][] matrix = mult(ryMatrix, rxMatrix);
+
+        int i = 0;
+        for (int dy = 0; dy < length; dy++) {
+            for (int dx = 0; dx < base; dx++) {
+                for (int dz = 0; dz < base; dz++) {
+
+                    if (dy <= base + random.nextInt(4)) {
+                        place(world, Blocks.NETHERRACK_CRYSTALLINE.id(), x, y, z, dx + i + 0.5f, dy + 0.5f, dz + i + 0.5f, matrix);
+                    } else {
+                        place(world, Blocks.CRYSTAL.id(), x, y, z, dx + i + 0.5f, dy + 0.5f, dz + i + 0.5f, matrix);
+                    }
+                }
+            }
+            if (random.nextFloat() > 0.95) {
+                base -= 2;
+                i += 1;
+                if (base <= 1) {
+                    break;
+                }
+            }
+        }
+        int yy = length;
+        while (true) {
+            base -= 2;
+            i += 1;
+            if (base <= 0) {
+                break;
+            }
+            for (int dx = 0; dx < base; dx++) {
+                for (int dz = 0; dz < base; dz++) {
+                    place(world, Blocks.CRYSTAL.id(), x, y, z, dx + i, yy, dz + i, matrix);
+                }
+            }
+            yy++;
+        }
+    }
+
+    private float[][] mult(float[][] ma, float[][] mb) {
+        float a = ma[0][0], b = ma[0][1], c = ma[0][2],
+              d = ma[1][0], e = ma[1][1], f = ma[1][2],
+              g = ma[2][0], h = ma[2][1], i = ma[2][2];
+        float j = mb[0][0], k = mb[0][1], l = mb[0][2],
+              m = mb[1][0], n = mb[1][1], o = mb[1][2],
+              p = mb[2][0], q = mb[2][1], r = mb[2][2];
+
+        return new float[][] {
+            {a * j + b * m + c * p, a * k + b * n + c * q, a * l + b * o + c * r},
+            {d * j + e * m + f * p, d * k + e * n + f * q, d * l + e * o + f * r},
+            {g * j + h * m + i * p, g * k + h * n + i * q, g * l + h * o + i * r}
+        };
+    }
+
+    private float[] mult(float[][] m, float[] v) {
+        return new float[] {
+            m[0][0] * v[0] + m[0][1] * v[1] + m[0][2] * v[2],
+            m[1][0] * v[0] + m[1][1] * v[1] + m[1][2] * v[2],
+            m[2][0] * v[0] + m[2][1] * v[1] + m[2][2] * v[2]
+        };
+    }
+
+    private void place(World world, int id, int ox, int oy, int oz, float dx, float dy, float dz, float[][] m) {
+        float[] v = {dx, dy, dz};
+        float[] t = mult(m, v);
+
+        int x = ox + MathHelper.floor(t[0]);
+        int y = oy + MathHelper.floor(t[1]);
+        int z = oz + MathHelper.floor(t[2]);
+
+        world.setBlock(x, y, z, id);
+        world.setBlock(x + 1, y, z, id);
+        world.setBlock(x, y, z + 1, id);
+        world.setBlock(x + 1, y, z + 1, id);
+
+        world.setBlock(x, y + 1, z, id);
+        world.setBlock(x + 1, y + 1, z, id);
+        world.setBlock(x, y + 1, z + 1, id);
+        world.setBlock(x + 1, y + 1, z + 1, id);
+
+        world.markBlocksDirty(x, y, z, x + 1, y + 1, z + 1);
+    }
+
+    private boolean hasSpace(World world, int x, int y, int z, int base){
+        for (int yi = y; yi < y + base; yi++) {
+            for (int xi = x - base; xi < x + base; xi++) {
+                for (int zi = z - base; zi < z + base; zi++) {
+                    if (world.getBlockId(xi, yi, zi) == Blocks.CRYSTAL.id())
+                        return false;
+                }
+            }
+        }
+        return true;
+    }
+}
